viSetGet = {};

function viSetGet:setVehicles(self)
	viVehicles = {};
	VehicleInspector.foundMaxAttached = 0;
	VehicleInspector.foundVehicleWarnings = 0;
	VehicleInspector.maxAttachedVehicleWarnings = 0;
	--for a=1, 6 do --1 tractor,drescher,frontloader,telehandler,wheelloader,rest
		--moVehicles.sort[a] = {};
	--end;
	--moGeneralSettings.vehicleControlled[1] = 0;
	--if moGeneralSettings.vehicleControlled[2] == nil then
	--	moGeneralSettings.vehicleControlled[2] = {};
	--end;
	local vehiclesLength = table.getn(g_currentMission.steerables);
	--local vehiclesLength = table.getn(g_currentMission.vehicles); 
	if vehiclesLength > 0 then 
		local b = 0;
		for a=1, vehiclesLength do 
			local vehicle = g_currentMission.steerables[a];	
			local rootNode = Utils.getNoNil(vehicle.rootNode, 0);
			if rootNode ~= nil and rootNode ~= 0 then				
				if viGui.defaultHud.storeItems then viSetGet:loadStoreItem(vehicle);end;				
				viSetGet:setVehicleName(self, vehicle, false);
				local controllerShortName = viSetGet:getControllerShortName(vehicle);
				vehicle.controllerShortName = controllerShortName;
				viSetGet:setVehicleViTables(self, vehicle, false, vehicle);				
				if viSetGet:seeVehicle(self, vehicle) then 
					b = b+1;
					viVehicles[b] = {};
					viVehicles[b].rootNode = rootNode;
					VehicleInspector.controlledName = viSetGet:getControllerName(vehicle);
					VehicleInspector.controlledVehicle = rootNode;
					VehicleInspector.controlledVehicleShortName = controllerShortName;										
					local isAttached, hardAttached, frontAttached, backAttached = viSetGet:getVehicleAttached(self, vehicle);
					if vehicle.viAttachedTable ~= nil then vehicle.viAttachedTable = nil;end;
					--if isAttached then						
						vehicle.viAttachedTable = {isAttached=isAttached, hardAttached=hardAttached, frontAttached=frontAttached, backAttached=backAttached};
					--end;					
				end;
				if vehicle.viValue.globalWarning.isWarning then VehicleInspector.foundVehicleWarnings = VehicleInspector.foundVehicleWarnings+1;end;
			end;
		end;		
		if viVehicles ~= nil and #viVehicles > 0 then 
			sortVehicles(self);
			VehicleInspector.foundMaxAttached = 0;
			for a=1, #viVehicles do
				if viVehicles[a].rootNode ~= nil and g_currentMission.nodeToVehicle[viVehicles[a].rootNode] ~= nil then				
					local vehicle = g_currentMission.nodeToVehicle[viVehicles[a].rootNode];
					if vehicle.viAttachedTable.isAttached then
						if VehicleInspector.foundMaxAttached < Utils.getNoNil(#vehicle.viAttachedTable.hardAttached, 0)+Utils.getNoNil(#vehicle.viAttachedTable.frontAttached, 0)+Utils.getNoNil(#vehicle.viAttachedTable.backAttached, 0) then
							VehicleInspector.foundMaxAttached = Utils.getNoNil(#vehicle.viAttachedTable.hardAttached, 0)+Utils.getNoNil(#vehicle.viAttachedTable.frontAttached, 0)+Utils.getNoNil(#vehicle.viAttachedTable.backAttached, 0);
						end;
						if VehicleInspector.maxAttachedVehicleWarnings < Utils.getNoNil(#vehicle.viAttachedTable.hardAttached, 0)+Utils.getNoNil(#vehicle.viAttachedTable.frontAttached, 0)+Utils.getNoNil(#vehicle.viAttachedTable.backAttached, 0) then
							VehicleInspector.maxAttachedVehicleWarnings = Utils.getNoNil(#vehicle.viAttachedTable.hardAttached, 0)+Utils.getNoNil(#vehicle.viAttachedTable.frontAttached, 0)+Utils.getNoNil(#vehicle.viAttachedTable.backAttached, 0);
						end;
					end;
				end;
			end;
			if viGui.defaultHud.seeExtraIcon.isDraw then
				VehicleInspector.foundMaxAttached = VehicleInspector.foundMaxAttached+1; --for extra icons
			end;
		end;		
	end;
end;

function sortVehicles(self)
	local foundSortBy = false;
	function sortBy(sortType1, sortType2, isString, isBoolean, isInt, isSpeziale)
		local newTable = {};		
		for a=1, #viVehicles do 		
			if viVehicles[a].rootNode ~= nil and g_currentMission.nodeToVehicle[viVehicles[a].rootNode] ~= nil then				
				local vehicle = g_currentMission.nodeToVehicle[viVehicles[a].rootNode];
				if vehicle ~= nil then
					local isTrueSortOnly = false;
					local seeControlled = viSetGet:seeControlled(self, vehicle);
					local isWarning = Utils.getNoNil(vehicle.viValue.globalWarning.isWarning, false);
					local sortType = vehicle[sortType1]
					if isSpeziale == nil and sortType1 ~= nil and sortType2 ~= nil and vehicle[sortType1] ~= nil and vehicle[sortType1][sortType2] ~= nil then sortType = vehicle[sortType1][sortType2];end;	
					if isString and isSpeziale == nil then						
						newTable[#newTable+1] = {sortThis=Utils.getNoNil(sortType, "unknown"), rootNode=viVehicles[a].rootNode, isTrue=true, isPlayer=seeControlled, isWarning=isWarning};						
					elseif isBoolean and isSpeziale == nil then						
						local on = Utils.getNoNil(sortType, false);						
						if on then on = "a";isTrueSortOnly=true;else on = "b";end;
						newTable[#newTable+1] = {sortThis=on, rootNode=viVehicles[a].rootNode, isTrue=isTrueSortOnly, isPlayer=seeControlled, isWarning=isWarning};						
					elseif isInt and isSpeziale == nil then						
						--print("sortType...".. tostring(sortType).. " -cfg age...".. tostring(viGui.defaultHud.sortByOnlyValue.age))
						if not viGui.defaultHud.sortByOnly or seeControlled or isWarning then 
							isTrueSortOnly=true;
						else
							if tostring(sortType1)=="propertyState" and Utils.getNoNil(sortType, 0) == 2 then 
								isTrueSortOnly=true;
							end;							
							if tostring(sortType1)=="age" and not viGui.defaultHud.sortByOnlyValue.ageReverse and Utils.getNoNil(sortType, 0) >= viGui.defaultHud.sortByOnlyValue.age then isTrueSortOnly=true;end;
							if tostring(sortType1)=="age" and viGui.defaultHud.sortByOnlyValue.ageReverse and Utils.getNoNil(sortType, 0) <= viGui.defaultHud.sortByOnlyValue.age then isTrueSortOnly=true;end;
							if tostring(sortType1)=="modVeGS" and Utils.getNoNil(viGui.defaultHud.seeGroup[sortType], false) then isTrueSortOnly=true;end;
							if tostring(sortType1)=="dirtAmount" and not viGui.defaultHud.sortByOnlyValue.dirtAmountReverse and Utils.getNoNil(tonumber(sortType), 0)*100 >= tonumber(viGui.defaultHud.sortByOnlyValue.dirtAmount) then isTrueSortOnly=true;end;
							if tostring(sortType1)=="dirtAmount" and viGui.defaultHud.sortByOnlyValue.dirtAmountReverse and Utils.getNoNil(tonumber(sortType), 0)*100 <= tonumber(viGui.defaultHud.sortByOnlyValue.dirtAmount) then isTrueSortOnly=true;end;
							if tostring(sortType1)=="price" and not viGui.defaultHud.sortByOnlyValue.vehiclePriceReverse and Utils.getNoNil(tonumber(sortType), 0) >= tonumber(viGui.defaultHud.sortByOnlyValue.vehiclePrice) then isTrueSortOnly=true;end;
							if tostring(sortType1)=="price" and viGui.defaultHud.sortByOnlyValue.vehiclePriceReverse and Utils.getNoNil(tonumber(sortType), 0) <= tonumber(viGui.defaultHud.sortByOnlyValue.vehiclePrice) then isTrueSortOnly=true;end;
						end;
						newTable[#newTable+1] = {sortThis=Utils.getNoNil(sortType, 0), rootNode=viVehicles[a].rootNode, isTrue=isTrueSortOnly, isPlayer=seeControlled, isWarning=isWarning};
					elseif isSpeziale and isSpeziale == 0 then										
						newTable[#newTable+1] = {rootNode=viVehicles[a].rootNode, sortThis=viVehicles[a].rootNode, isTrue=true, isPlayer=seeControlled, isWarning=isWarning};
					elseif isSpeziale and isSpeziale == 1 then
						local fillLevel, capacity = viSetGet:getAttachedTrailersFillLevelAndCapacity(vehicle, 0, 0);						
						if fillLevel == nil then fillLevel = -1;end;						
						sortType = Utils.getNoNil(g_i18n:formatNumber(fillLevel), 0);						
						if not viGui.defaultHud.sortByOnly or seeControlled or isWarning then  
							isTrueSortOnly=true;
						else
							if tostring(sortType1)=="getAttachedTrailersFillLevelAndCapacity" and not viGui.defaultHud.sortByOnlyValue.fillLevelReverse and tonumber(sortType) >= tonumber(g_i18n:formatNumber(viGui.defaultHud.sortByOnlyValue.fillLevel)) then isTrueSortOnly=true;end;
							if tostring(sortType1)=="getAttachedTrailersFillLevelAndCapacity" and viGui.defaultHud.sortByOnlyValue.fillLevelReverse and tonumber(sortType) <= tonumber(g_i18n:formatNumber(viGui.defaultHud.sortByOnlyValue.fillLevel)) then isTrueSortOnly=true;end;
						end;
						newTable[#newTable+1] = {sortThis=tonumber(sortType), rootNode=viVehicles[a].rootNode, isTrue=isTrueSortOnly, isPlayer=seeControlled, isWarning=isWarning};						
					elseif isInt and isSpeziale and isSpeziale == 2 then
						local fuelFillLevel = Utils.getNoNil(vehicle[sortType1], 100000);
						local fuelCapacity = Utils.getNoNil(vehicle[sortType2], 100000);
						sortType = tonumber(viSetGet:getProzentString(fuelFillLevel, fuelCapacity));
						if not viGui.defaultHud.sortByOnly or seeControlled or isWarning then 
							isTrueSortOnly=true;
						else	
							if tostring(sortType1)=="fuelFillLevel" and not viGui.defaultHud.sortByOnlyValue.fuelProzentReverse and tonumber(sortType) <= tonumber(viGui.defaultHud.sortByOnlyValue.fuelProzent) then isTrueSortOnly=true;end;
							if tostring(sortType1)=="fuelFillLevel" and viGui.defaultHud.sortByOnlyValue.fuelProzentReverse and tonumber(sortType) >= tonumber(viGui.defaultHud.sortByOnlyValue.fuelProzent) then isTrueSortOnly=true;end;
						end;
						newTable[#newTable+1] = {sortThis=tonumber(sortType), rootNode=viVehicles[a].rootNode, isTrue=isTrueSortOnly, isPlayer=seeControlled, isWarning=isWarning};
					elseif isSpeziale and isSpeziale == 3 then
						local sellPrice, price, multiplier = viSetGet:getSellPriceAndMulitplier(self, vehicle);						
						sortType = Utils.getNoNil(g_i18n:formatNumber(sellPrice), 0);
						if not viGui.defaultHud.sortByOnly or seeControlled or isWarning then 
							isTrueSortOnly=true;
						else	
							if tostring(sortType1)=="price" and not viGui.defaultHud.sortByOnlyValue.vehicleSellPriceReverse and tonumber(sortType) >= tonumber(g_i18n:formatNumber(viGui.defaultHud.sortByOnlyValue.vehicleSellPrice)) then isTrueSortOnly=true;end;
							if tostring(sortType1)=="price" and viGui.defaultHud.sortByOnlyValue.vehicleSellPriceReverse and tonumber(sortType) <= tonumber(g_i18n:formatNumber(viGui.defaultHud.sortByOnlyValue.vehicleSellPrice)) then isTrueSortOnly=true;end;
						end;
						newTable[#newTable+1] = {sortThis=tonumber(sortType), rootNode=viVehicles[a].rootNode, isTrue=isTrueSortOnly, isPlayer=seeControlled, isWarning=isWarning};
					end;
				end;
			end;
		end;
		function comp(w1,w2)			
			if w1.sortThis > w2.sortThis then
				return true;
			end;			
		end;
		function comp1(w1,w2)						
			if w1.sortThis < w2.sortThis then				
				return true;
			end;
		end;
		if tostring(sortType1) == "dirtAmount" or tostring(sortType1) == "price" or tostring(sortType1) == "age" or tostring(sortType1) == "propertyState" or tostring(sortType1) == "getAttachedTrailersFillLevelAndCapacity" or (tostring(sortType1) == "modVeGS" and viGui.defaultHud.seeGroup[11]) then
			table.sort(newTable, comp1);
		else
			table.sort(newTable, comp);
		end;		
		viVehicles = {};
		local sortPlayer = viGui.defaultHud.seeControlled.player or viGui.defaultHud.seeControlled.foreignPlayer or viGui.defaultHud.seeControlled.hired;
		if sortPlayer then viVehiclesPlayers = {};end;		
		for a=1, #newTable do 		
			if viGui.defaultHud.sortByReverse then
				if (viGui.defaultHud.sortByOnly and newTable[a].isTrue and not sortPlayer) or (viGui.defaultHud.sortByOnly and newTable[a].isTrue and sortPlayer and not newTable[a].isPlayer) or (viGui.defaultHud.sortByOnly and newTable[a].isTrue and sortPlayer and newTable[a].isPlayer and not viGui.defaultHud.seeControlled.first) or (viGui.defaultHud.sortByOnly and not newTable[a].isTrue and sortPlayer and newTable[a].isPlayer and not viGui.defaultHud.seeControlled.first) then
					table.insert(viVehicles, #viVehicles+1, {rootNode=newTable[a].rootNode});
					viSetGet:setMaxFoundAttached(newTable[a].rootNode);
				elseif (not viGui.defaultHud.sortByOnly and not sortPlayer) or (not viGui.defaultHud.sortByOnly and sortPlayer and not newTable[a].isPlayer) or (not viGui.defaultHud.sortByOnly and sortPlayer and newTable[a].isPlayer and not viGui.defaultHud.seeControlled.first) then
					table.insert(viVehicles, #viVehicles+1, {rootNode=newTable[a].rootNode});
					viSetGet:setMaxFoundAttached(newTable[a].rootNode);
				elseif (sortPlayer and newTable[a].isPlayer) then
					table.insert(viVehiclesPlayers, 1, {rootNode=newTable[a].rootNode});					
				end;
			else
				if (viGui.defaultHud.sortByOnly and newTable[a].isTrue and not sortPlayer) or (viGui.defaultHud.sortByOnly and newTable[a].isTrue and sortPlayer and not newTable[a].isPlayer) or (viGui.defaultHud.sortByOnly and newTable[a].isTrue and sortPlayer and newTable[a].isPlayer and not viGui.defaultHud.seeControlled.first) or (viGui.defaultHud.sortByOnly and not newTable[a].isTrue and sortPlayer and newTable[a].isPlayer and not viGui.defaultHud.seeControlled.first) then
					table.insert(viVehicles, 1, {rootNode=newTable[a].rootNode});
					viSetGet:setMaxFoundAttached(newTable[a].rootNode);
				elseif (not viGui.defaultHud.sortByOnly and not sortPlayer) or (not viGui.defaultHud.sortByOnly and sortPlayer and not newTable[a].isPlayer) or (not viGui.defaultHud.sortByOnly and sortPlayer and newTable[a].isPlayer and not viGui.defaultHud.seeControlled.first) then
					table.insert(viVehicles, 1, {rootNode=newTable[a].rootNode});
					viSetGet:setMaxFoundAttached(newTable[a].rootNode);
				elseif (sortPlayer and newTable[a].isPlayer) then
					table.insert(viVehiclesPlayers, 1, {rootNode=newTable[a].rootNode});					
				end;				
			end;			
		end;		
		if sortPlayer and #viVehiclesPlayers > 0 and viGui.defaultHud.seeControlled.first then			
			for a=1, #viVehiclesPlayers do
				if viGui.defaultHud.seeControlled.firstPos == 0 then
					table.insert(viVehicles, 1, {rootNode=viVehiclesPlayers[a].rootNode});
					viSetGet:setMaxFoundAttached(viVehiclesPlayers[a].rootNode);
				else
					table.insert(viVehicles, #viVehicles+1, {rootNode=viVehiclesPlayers[a].rootNode});
					viSetGet:setMaxFoundAttached(viVehiclesPlayers[a].rootNode);
				end;
			end;
		end;
	end;
	--function comp(w1,w2)
	--	if w1.rootNode > w2.rootNode then
	--		return true;
	--	end
	--end		
	--table.sort(viVehicles, comp);
	for key,value in pairs(viGui.defaultHud.sortBy) do		
		--print("sortBy key und value ...".. tostring(key).. "-----".. tostring(value))
		if viGui.defaultHud.sortBy[key] then
			foundSortBy = true;
			if tostring(key) == "vehicleName" then
				sortBy("viVehicleName", nil, true, false, false, nil);
			elseif tostring(key) == "typeName" then
				sortBy("typeName", nil, true, false, false, nil);
			elseif tostring(key) == "typeDesc" then
				sortBy("typeDesc", nil, true, false, false, nil);
			elseif tostring(key) == "engineOn" then
				sortBy("isMotorStarted", nil, false, true, false, nil);
			elseif tostring(key) == "isGroup" and VehicleInspector.foundGroupManager then				
				sortBy("modVeGS", "group", false, false, true, nil);	
			elseif tostring(key) == "isPlayer" then
			elseif tostring(key) == "isHired" then
				sortBy("isHired", nil, false, true, false, nil);
			elseif tostring(key) == "isAttached" then
				sortBy("viAttachedTable", "isAttached", false, true, false, nil);
			elseif tostring(key) == "age" then
				sortBy("age", nil, false, false, true, nil);
			elseif tostring(key) == "rentCar" then
				sortBy("propertyState", nil, false, false, true, nil);
			elseif tostring(key) == "isControlled" then
				sortBy("isControlled", nil, false, true, false, nil);
			elseif tostring(key) == "isFillLevel" then
				sortBy("getAttachedTrailersFillLevelAndCapacity", nil, false, false, false, 1);	
			elseif tostring(key) == "isFuel" then
				sortBy("fuelFillLevel", "fuelCapacity", false, false, true, 2);	
			elseif tostring(key) == "dirtAmount" then
				sortBy("dirtAmount", nil, false, false, true, nil);	
			elseif tostring(key) == "vehiclePrice" then
				sortBy("price", nil, false, false, true, nil);
			elseif tostring(key) == "vehicleSellPrice" then
				sortBy("price", nil, false, false, nil, 3);	
			end;			
			break;			
		end;		
	end;
	if not foundSortBy then sortBy("rootNode", nil, false, false, true, 0);end;
end;

function viSetGet:getControllerShortName(vehicle)
	local controllerShortName = "N";
	if Utils.getNoNil(vehicle.isControlled, false) or Utils.getNoNil(vehicle.isHired, false) then		
		local foundName = false;
		if Utils.getNoNil(vehicle.isHired, false) then controllerShortName="H";end;
		if vehicle.controllerName == g_currentMission.player.controllerName then controllerShortName="P";foundName=true;end;
		if vehicle.controllerName == g_currentMission.player.controllerName and Utils.getNoNil(vehicle.isHired, false) then controllerShortName = "P-H";foundName=true;end;
		if vehicle.controllerName ~= g_currentMission.player.controllerName then controllerShortName="AP";foundName=true;end;
		if vehicle.controllerName ~= g_currentMission.player.controllerName and Utils.getNoNil(vehicle.isHired, false) then controllerShortName = "AP-H";foundName=true;end;
		if vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving() then controllerShortName="HC";foundName=true;end;
		if (vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving()) and vehicle.controllerName == g_currentMission.player.controllerName then controllerShortName="P-HC";foundName=true;end;
		if (vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving()) and vehicle.controllerName ~= g_currentMission.player.controllerName then controllerShortName="AP-HC";foundName=true;end;
		if (vehicle.getIsFollowMeActive ~= nil and vehicle:getIsFollowMeActive()) and vehicle.controllerName == g_currentMission.player.controllerName then controllerShortName="P-HF";foundName=true;end;
		if (vehicle.getIsFollowMeActive ~= nil and vehicle:getIsFollowMeActive()) and vehicle.controllerName ~= g_currentMission.player.controllerName then controllerShortName="AP-HF";foundName=true;end;
		if not foundName then controllerShortName = "U";end;
	end;
	return controllerShortName;
end;

function viSetGet:getControllerName(vehicle)
	if Utils.getNoNil(vehicle.isControlled, false) then
		return vehicle.controllerName;
	end;
	return nil;
end;

function viSetGet:setMaxFoundAttached(rootNode)
	local maxAttached = viGui.defaultHud.attachedView;
	local foundAttached = 0;
	local vehicle;
	if g_currentMission.nodeToVehicle[rootNode] ~= nil then	vehicle = g_currentMission.nodeToVehicle[rootNode];end;
	if vehicle ~= nil and vehicle.viAttachedTable ~= nil and vehicle.viAttachedTable.isAttached then
		foundAttached = #vehicle.viAttachedTable.hardAttached+#vehicle.viAttachedTable.frontAttached+#vehicle.viAttachedTable.backAttached;		
	end;
	if foundAttached <= maxAttached and foundAttached >= VehicleInspector.foundMaxAttached then VehicleInspector.foundMaxAttached=foundAttached;end;
end;

function viSetGet:getVehicleAttached(self, vehicle)
	local frontAttached = {};
	local backAttached = {};
	local hardAttached = {};
	local isAttached = false;
	local foundFront = false;
	local foundBack = false;
	local maxAttached = viGui.defaultHud.attachedView;
	local foundAttached = 0;
	function setAttached(attachedObj, hardImplement, frontImplement, backImplement)
		if foundAttached >= maxAttached then return;end;
		foundAttached = foundAttached+1;
		if viGui.defaultHud.storeItems then viSetGet:loadStoreItem(attachedObj);end;
		viSetGet:setVehicleName(self, attachedObj, true)
		local joinTypeName = Utils.getNoNil(attachedObj.typeName, "unknown");
		viSetGet:setVehicleViTables(self, attachedObj, true, vehicle);
		if hardImplement then			
			if getSeeAttached(attachedObj, joinTypeName) or Utils.getNoNil(vehicle.viValue.globalWarning.isWarning, false) then
				table.insert(hardAttached, 1, attachedObj.rootNode);
			else
				foundAttached = foundAttached-1;
			end;
		elseif frontImplement then			
			if getSeeAttached(attachedObj, joinTypeName) or Utils.getNoNil(vehicle.viValue.globalWarning.isWarning, false) then 
				table.insert(frontAttached, 1, attachedObj.rootNode);
			else
				foundAttached = foundAttached-1;
			end;				
		else
			if getSeeAttached(attachedObj, joinTypeName) or Utils.getNoNil(vehicle.viValue.globalWarning.isWarning, false) then 
				table.insert(backAttached, #backAttached+1, attachedObj.rootNode);
			else
				foundAttached = foundAttached-1;
			end;
		end;
		if attachedObj.attachedImplements then
			for index,attached in pairs(attachedObj.attachedImplements) do
				if attached ~= nil and attached.object ~= nil then				
					if foundAttached >= maxAttached then break;end;
					setAttached(attached.object, hardImplement, frontImplement, backImplement);				
				end;
			end;
		end;
	end;
	if vehicle.attachedImplements and vehicle.attachedImplements[1] ~= nil then		
		for index,attached in pairs(vehicle.attachedImplements) do
			if attached ~= nil and attached.object ~= nil then				
				isAttached = true;
				if foundAttached >= maxAttached then break;end;
				local back = false;
				local front = false;
				if not Utils.getNoNil(attached.object.isHardAttached, false) then					
					local joinTypeName = viSetGet:getJoinTypeName(attached);
					if joinTypeName ~= nil and viSetGet:isFrontAttached(joinTypeName) and not foundFront then
						front=true;
						foundFront=true;
					elseif attached.object.getImplementIndexByJointDescIndex ~= nil and attached.object.getImplementIndexByJointDescIndex(vehicle, 1) ~= nil or (joinTypeName == "trailer" or joinTypeName == "trailerLow" or joinTypeName == "semitrailerHook" or joinTypeName == "hookLift") and not foundBack then 
						back=true;
						foundBack=true;
					elseif attached.object.getImplementIndexByJointDescIndex ~= nil and attached.object.getImplementIndexByJointDescIndex(vehicle, 2) ~= nil and not foundFront then 
						front=true;
						foundFront=true;
					else
						back=true;
						foundBack=true;
					end;					
				end;
				setAttached(attached.object, Utils.getNoNil(attached.object.isHardAttached, false), front, back);				
			end;
		end;
	end;
	if foundAttached > VehicleInspector.foundMaxAttached then VehicleInspector.foundMaxAttached = foundAttached;end;
	return isAttached,hardAttached,frontAttached,backAttached;
end;

function viSetGet:loadStoreItem(vehicle)	
	local xmlVehicle = string.lower(vehicle.configFileName);	
	local storeItem = StoreItemsUtil.storeItemsByXMLFilename[xmlVehicle];
	local r = viExtras.colors[viGui.defaultHud.designGroundColor[viGui.defaultHud.storeItemsColorMarker]][1];
	local g = viExtras.colors[viGui.defaultHud.designGroundColor[viGui.defaultHud.storeItemsColorMarker]][2];
	local b = viExtras.colors[viGui.defaultHud.designGroundColor[viGui.defaultHud.storeItemsColorMarker]][3];
	local t = viGui.defaultHud.storeItemsTransparent;
	if storeItem ~= nil and vehicle.viVehicleName ~= "Heli" then
		if viStoreItems[xmlVehicle] == nil then
			viStoreItems[xmlVehicle] = Overlay:new(tostring(xmlVehicle), storeItem.imageActive, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*10, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*9);
			viGui:setBackgroundColor(self, viStoreItems[xmlVehicle], {r,g,b,t});			
		end;
		vehicle.viStoreItem = xmlVehicle;
	elseif vehicle.viVehicleName == "Train" then
		if viStoreItems["Train"] == nil then			
			viStoreItems["Train"] = viGui["trainStore"];
			viGui:setBackgroundColor(self, viStoreItems["Train"], {r,g,b,t});
		end;
		vehicle.viStoreItem = "Train";
	elseif vehicle.viVehicleName == "Crane" then
		if viStoreItems["Crane"] == nil then
			viStoreItems["Crane"] = viGui["craneStore"];
			viGui:setBackgroundColor(self, viStoreItems["Crane"], {r,g,b,t});
		end;
		vehicle.viStoreItem = "Crane";
	elseif vehicle.viVehicleName == "WagonFill" then
		if viStoreItems["WagonFill"] == nil then
			viStoreItems["WagonFill"] = viGui["wagonStore"];
			viGui:setBackgroundColor(self, viStoreItems["WagonFill"], {r,g,b,t});
		end;
		vehicle.viStoreItem = "WagonFill";
	elseif vehicle.viVehicleName == "WagonTimber" then
		if viStoreItems["WagonTimber"] == nil then
			viStoreItems["WagonTimber"] = viGui["wagonTimberStore"];
			viGui:setBackgroundColor(self, viStoreItems["WagonTimber"], {r,g,b,t});
		end;
		vehicle.viStoreItem = "WagonTimber";
	elseif vehicle.viVehicleName == "Heli" then
		if viStoreItems["Heli"] == nil then
			viStoreItems["Heli"] = viGui["heliStore"];
			viGui:setBackgroundColor(self, viStoreItems["Heli"], {r,g,b,t});
		end;
		vehicle.viStoreItem = "Heli";	
	end;	
end;

function getSeeAttached(attached, joinTypeName)
	--print("joinTypeName...".. tostring(joinTypeName))
	if not viGui.defaultHud.seeAttached.setFilter then return true;end;
	if joinTypeName ~= nil then
		if joinTypeName == "unknown" then 
			joinTypeName = Utils.getNoNil(attached.typeDesc, "unknown");			
		end;
		if viGui.defaultHud.seeAttached[joinTypeName] ~= nil then
			if not viGui.defaultHud.seeAttached[joinTypeName] then return false;end;
		end;		
	end;
	return true;
end;

function viSetGet:isFrontAttached(joinTypeName)
	if joinTypeName == "cutter" or joinTypeName == "cutterHarvester" or joinTypeName == "skidSteer" or joinTypeName == "telehandler" or joinTypeName == "wheelLoader" then return true;end;
	return false;
end;

function viSetGet:getJoinTypeName(attached)
	local joinTypeName = nil;
	local joinType = viSetGet:getJoinType(attached);
	if joinType ~= 0 then
		for name,value in pairs(AttacherJoints.jointTypeNameToInt) do
			if value == joinType then
				joinTypeName = name;
				break;
			end;
		end;
	end;
	return joinTypeName;
end;

function viSetGet:getJoinType(attached)
	local joinType = 0;
	if attached.object.inputAttacherJoints ~= nil then
		for j,inputAttacherJoint in pairs (attached.object.inputAttacherJoints) do
			joinType = inputAttacherJoint.jointType;
		end;
	end;
	return joinType;
end;

function viSetGet:setVehicleName(self, vehicle, attachable)
	if vehicle.viVehicleName ~= nil then return;end;
	local vehicleName = "Unknown";
	local category = "Unknown";
	local storeItem = StoreItemsUtil.storeItemsByXMLFilename[vehicle.configFileName:lower()];
    if storeItem ~= nil then
        if storeItem.name ~= nil then
            vehicleName = tostring(storeItem.name);
        end;
        --if storeItem.category ~= nil and storeItem.category ~= "" then
        --    category = tostring(storeItem.category);
        --end;
	end;
	--print("vehiclename...".. tostring(name).. " -category...".. tostring(category))
	
	
	--local vehicleXml = loadXMLFile("MultiOverlayV2_XML", vehicle.configFileName, "vehicle");
	if string.find(tostring(vehicle.configFileName), "locomotive") then
		vehicleName = "Train";		
		if not attachable then vehicle.typeDesc = vehicleName;end;
	elseif string.find(tostring(vehicle.configFileName), "stationCrane") then
		vehicleName = "Crane";
		if not attachable then vehicle.typeDesc = vehicleName;end;
	elseif string.find(tostring(vehicle.configFileName), "wagon") then
		vehicleName = "WagonFill";
		if string.find(tostring(vehicle.configFileName:lower()), "timber") then
			vehicleName = "WagonTimber";
		end;
		if attachable then vehicle.typeDesc = vehicleName;end;
	elseif string.find(tostring(vehicle.configFileName), "ka26") then
		vehicleName = "Heli";
		if not attachable then vehicle.typeDesc = vehicleName;end;
	elseif vehicle.time ~= nil and vehicle.time > 0 then
		vehicleName = vehicleName.. "-Missions Vehicle";
	end;
	--tableVehicle.name = vehicleName;	
	vehicle.viVehicleName = vehicleName;
end;

function viSetGet:getAttachedTrailersFillLevelAndCapacity(vehicle, fillLevelFirst, capacityFirst)
    local fillLevel = fillLevelFirst;
    local capacity = capacityFirst;
    local hasTrailer = false;
    if vehicle.getFillLevel ~= nil and vehicle.getCapacity ~= nil then
        fillLevel = fillLevel + vehicle:getFillLevel();
        capacity = capacity + vehicle:getCapacity();
        hasTrailer = true;
    end;
    for _, implement in pairs(vehicle.attachedImplements) do
        if implement.object ~= nil then
            local f, c = viSetGet:getAttachedTrailersFillLevelAndCapacity(implement.object, fillLevel, capacity);
            if f ~= nil and c ~= nil then
                fillLevel = fillLevel + f;
                capacity = capacity + c;
                hasTrailer = true;
            end;
        end
    end;
    if hasTrailer then
        return fillLevel, capacity;
    end;
    return nil;
end;

function viSetGet:seeVehicle(self, vehicle)
	local isDraw = false;
	--print("joinTypeName...".. tostring(vehicle.typeName))
	if vehicle.viVehicleName == "Train" then 
		isDraw = viGui.defaultHud.seeVehicle.train;	
		if not isDraw then
			if viGui.defaultHud.seeControlled.playerTrain and (string.find(vehicle.controllerShortName, "P") and not string.find(vehicle.controllerShortName, "AP")) then
				isDraw = true;
			elseif viGui.defaultHud.seeControlled.foreignPlayerTrain and string.find(vehicle.controllerShortName, "AP") then
				isDraw = true;
			elseif viGui.defaultHud.seeControlled.hiredTrain and string.find(vehicle.controllerShortName, "H") then
				isDraw = true;	
			end;
		end;
	elseif vehicle.viVehicleName == "Crane" then
		isDraw = viGui.defaultHud.seeVehicle.crane;
		if not isDraw then
			if viGui.defaultHud.seeControlled.playerCrane and (string.find(vehicle.controllerShortName, "P") and not string.find(vehicle.controllerShortName, "AP")) then
				isDraw = true;
			elseif viGui.defaultHud.seeControlled.foreignPlayerCrane and string.find(vehicle.controllerShortName, "AP") then
				isDraw = true;
			end;
		end;
	elseif vehicle.viVehicleName == "Heli" then
		isDraw = viGui.defaultHud.seeVehicle.heli;
		if not isDraw then
			if viGui.defaultHud.seeControlled.playerHeli and (string.find(vehicle.controllerShortName, "P") and not string.find(vehicle.controllerShortName, "AP")) then
				isDraw = true;
			elseif viGui.defaultHud.seeControlled.foreignPlayerHeli and string.find(vehicle.controllerShortName, "AP") then
				isDraw = true;
			end;
		end;
	elseif not VehicleInspector.isMp and not vehicle.isVehicleSaved then
		isDraw = true; --Mission Vehicle
	elseif viSetGet:seeControlled(self, vehicle) then
		isDraw = true;
	elseif not viGui.defaultHud.seeVehicle.setFilter then
		isDraw = true;
	else
		isDraw = Utils.getNoNil(viGui.defaultHud.seeVehicle[vehicle.typeName], false);
		if not isDraw and (Utils.getNoNil(vehicle.viValue.globalWarning.isWarning,false) or Utils.getNoNil(vehicle.viValue.globalWarning.foundDirtAmount > 0,false)) then
			isDraw = true;
		end;
	end;
	return isDraw;
end;

function viSetGet:seeControlled(self, vehicle)	
	if viGui.defaultHud.seeControlled.hired and string.find(vehicle.controllerShortName, "H") then
		if vehicle.viVehicleName == "Train" and viGui.defaultHud.seeControlled.hiredTrain then
			return true;
		elseif vehicle.viVehicleName ~= "Train" then
			return true;
		end;
	end;
	if viGui.defaultHud.seeControlled.player and string.find(vehicle.controllerShortName, "P") and not string.find(vehicle.controllerShortName, "AP") then
		if vehicle.viVehicleName == "Train" and viGui.defaultHud.seeControlled.playerTrain then
			return true;
		elseif vehicle.viVehicleName == "Crane" and viGui.defaultHud.seeControlled.playerCrane then
			return true;
		elseif vehicle.viVehicleName == "Heli" and viGui.defaultHud.seeControlled.playerHeli then
			return true;	
		elseif vehicle.viVehicleName ~= "Train" and vehicle.viVehicleName ~= "Crane" and vehicle.viVehicleName ~= "Heli"then
			return true;
		end;
	end;
	if viGui.defaultHud.seeControlled.forgeignPlayer and string.find(vehicle.controllerShortName, "AP") then
		if vehicle.viVehicleName == "Train" and viGui.defaultHud.seeControlled.foreignPlayerTrain then
			return true;
		elseif vehicle.viVehicleName == "Crane" and viGui.defaultHud.seeControlled.foreignPlayerCrane then
			return true;
		elseif vehicle.viVehicleName == "Heli" and viGui.defaultHud.seeControlled.foreignPlayerHeli then
			return true;	
		elseif vehicle.viVehicleName ~= "Train" and vehicle.viVehicleName ~= "Crane" and vehicle.viVehicleName ~= "Heli" then
			return true;
		end;		
	end;
	return false;
end;

function viSetGet:getFuelLevel(self, vehicle, getProzent)
	local fuelLevel = nil;
	if vehicle.fuelFillLevel ~= nil then
		fuelLevel = vehicle.fuelFillLevel;
		if getProzent then
			local fuelCapacity = viSetGet:getFuelCapacity(self, vehicle, false);
			if fuelCapacity ~= nil and fuelLevel ~= nil and tonumber(fuelCapacity) and tonumber(fuelLevel) then
				fuelLevel = tonumber(viSetGet:getProzentString(fuelLevel, fuelCapacity));
			else
				fuelLevel = nil;
			end;
		end;
	end;
	return fuelLevel;
end;

function viSetGet:getFuelCapacity(self, vehicle, getProzent)
	local fuelCapacity = nil;
	if vehicle.fuelCapacity ~= nil then
		fuelCapacity = vehicle.fuelCapacity;
		if getProzent then
			local fuelLevel = viSetGet:getFuelLevel(self, vehicle, false);
			if fuelLevel ~= nil and fuelCapacity ~= nil and tonumber(fuelCapacity) and tonumber(fuelLevel) then
				fuelCapacity = tonumber(viSetGet:getProzentString(fuelLevel, fuelCapacity));
			else
				fuelCapacity = nil;
			end;
		end;
	end;
	return fuelCapacity;
end;

function viSetGet:getFillLevel(self, vehicle, getProzent)
	local fillLevel = nil;
	if vehicle.viVehicleName == "Train" then return fillLevel;end;
	if vehicle.getFillLevel ~= nil then
		fillLevel = vehicle:getFillLevel();
		if getProzent then
			local capacity = viSetGet:getFillCapacity(self, vehicle, false);
			if capacity ~= nil and fillLevel ~= nil and tonumber(capacity) and tonumber(fillLevel) then
				fillLevel = tonumber(viSetGet:getProzentString(fillLevel, capacity));
			else
				fillLevel = nil;
			end;
		end;
	end;
	return fillLevel;
end;

function viSetGet:getFillCapacity(self, vehicle, getProzent)
	local capacity = nil;
	if vehicle.viVehicleName == "Train" then return capacity;end;
	if vehicle.getCapacity ~= nil then
		capacity = vehicle:getCapacity();
		if getProzent then
			local fillLevel = viSetGet:getFillLevel(self, vehicle, false);
			if fillLevel ~= nil and capacity ~= nil and tonumber(capacity) and tonumber(fillLevel) then
				capacity = tonumber(viSetGet:getProzentString(fillLevel, capacity));
			else
				capacity = nil;
			end;
		end;
	end;
	return capacity;
end;

function viSetGet:getProzentString(fill, capacity)	
	return string.format("%1.0f", "".. tonumber(fill)/tonumber(capacity)*100);
end;

function viSetGet:getSellPriceAndMulitplier(self, vehicle)
    local priceMultiplier = 0.75
	local xmlConfigFile = vehicle.configFileName:lower();
    if xmlConfigFile ~= nil and StoreItemsUtil.storeItemsByXMLFilename[xmlConfigFile] ~= nil and StoreItemsUtil.storeItemsByXMLFilename[xmlConfigFile].lifetime ~= nil then
		local maxVehicleAge = StoreItemsUtil.storeItemsByXMLFilename[xmlConfigFile].lifetime;
		if maxVehicleAge ~= nil and maxVehicleAge ~= 0 then
			local ageMultiplier = 0.5 * math.min(vehicle.age/maxVehicleAge, 1)
			local operatingTime = vehicle.operatingTime / (1000*60*60)
			local operatingTimeMultiplier =  0.5 * math.min(operatingTime / (maxVehicleAge*EconomyManager.LIFETIME_OPERATINGTIME_RATIO), 1)
			priceMultiplier = priceMultiplier * math.exp(-3.5 * (ageMultiplier+operatingTimeMultiplier))
			return math.floor(Utils.getNoNil(vehicle:getPrice(),0) * math.max(priceMultiplier, 0.05)), math.floor(Utils.getNoNil(vehicle:getPrice(),0)), math.max(priceMultiplier, 0.05);
		end;
	end;
    return 0, 0, math.max(priceMultiplier, 0.05);
end;

function viSetGet:getDailyUpKeep(self, vehicle)
   local xmlConfigFile = vehicle.configFileName:lower();
   local multiplier = 1;
   if xmlConfigFile ~= nil and StoreItemsUtil.storeItemsByXMLFilename[xmlConfigFile] ~= nil and StoreItemsUtil.storeItemsByXMLFilename[xmlConfigFile].lifetime ~= nil then
		local storeItem = StoreItemsUtil.storeItemsByXMLFilename[xmlConfigFile];
		local maxVehicleAge = StoreItemsUtil.storeItemsByXMLFilename[xmlConfigFile].lifetime;
		local multiplier = 1;
		if maxVehicleAge ~= nil and maxVehicleAge ~= 0 then
			local ageMultiplier = 0.3 * math.min(vehicle.age/maxVehicleAge, 1);
			local operatingTime = vehicle.operatingTime / (1000*60*60);
			local operatingTimeMultiplier =  0.7 * math.min(operatingTime / (maxVehicleAge*EconomyManager.LIFETIME_OPERATINGTIME_RATIO), 1);
			multiplier = 1 + EconomyManager.MAX_DAILYUPKEEP_MULTIPLIER * (ageMultiplier+operatingTimeMultiplier);
		end;
		return StoreItemsUtil.getDailyUpkeep(storeItem, vehicle.configurations) * multiplier, storeItem.dailyUpkeep;
	end;
	return 0, 0;
end;

function viSetGet:getDirtAmountProzentAndColor(self, vehicle)
	local dirtAmount = Utils.getNoNil(vehicle.dirtAmount, 0)*100;
	local washDuration = Utils.getNoNil(vehicle.washDuration, 0);
	return dirtAmount;
end;

function viSetGet:setVehicleViTables(self, vehicle, isAttached, masterVehicle)
	local warnings = 0;
	vehicle.viValue = {};
	if not isAttached then vehicle.viValue.globalWarning = {isWarning=false; warningTxt=""; foundRentCar=0; rentCarCost=0; foundDirtAmount=0; foundVehicleCost=0};end;	
	vehicle.viValue.fill = {isWarning=false;combineFill=false;fillLevel=0;fillLevelProzent=0;isSeedsOrSprayer=false};
	vehicle.viValue.fuel = {isWarning=false;fuelLevel=0;fuelLevelProzent=0};	
	vehicle.viValue.dirtAmount = {isWarning=false;dirtAmountProzent=0};	
	vehicle.viValue.price = {isWarning=false;sellPriceProzent=0};
	function setFuel()
		if vehicle.viVehicleName == "Crane" then
			vehicle.viValue.fuel.fuelLevel = 100;
			vehicle.viValue.fuel.fuelLevelProzent = 100;
		end;
		local fuelLevel = viSetGet:getFuelLevel(self, vehicle, false);
		local fuelCapacity = viSetGet:getFuelCapacity(self, vehicle, false);
		if fuelLevel ~= nil and fuelCapacity ~= nil then
			vehicle.viValue.fuel.fuelLevel = fuelLevel;
			vehicle.viValue.fuel.fuelLevelProzent = tonumber(viSetGet:getProzentString(fuelLevel, fuelCapacity));
			if viGui.defaultHud.seeNoDrawWarning.fuelLevel ~= -1 and tonumber(vehicle.viValue.fuel.fuelLevelProzent) <= viGui.defaultHud.seeNoDrawWarning.fuelLevel then
				vehicle.viValue.fuel.isWarning = true;
				if not isAttached or (isAttached and viGui.defaultHud.seeNoDrawWarning.attachedFuel) then
					masterVehicle.viValue.globalWarning.isWarning = true;				
				end;
				if tonumber(vehicle.viValue.fuel.fuelLevelProzent) <= 0 then masterVehicle.viValue.globalWarning.warningTxt = "! Fuel Empty !";end;
			end;
		end;
	end;
	function setFill()
		local fillLevel = viSetGet:getFillLevel(self, vehicle, false);
		local fillCapacity = viSetGet:getFillCapacity(self, vehicle, false);
		if fillLevel ~= nil and fillCapacity ~= nil then
			vehicle.viValue.fill.fillLevel = fillLevel;			
			local fillLevelProzent = tonumber(viSetGet:getProzentString(fillLevel, fillCapacity));
			local seeNoDrawWarningFillLevel = viGui.defaultHud.seeNoDrawWarning.fillLevel;
			vehicle.viValue.fill.fillLevelProzent = fillLevelProzent;
			if viGui.defaultHud.seeNoDrawWarning.fillLevel ~= -1 then
				if (vehicle.seeds ~= nil and vehicle.currentSeed ~= nil) or vehicle.sprayer ~= nil then					
					if vehicle.seeds ~= nil and vehicle.currentSeed ~= nil and vehicle.sprayer ~= nil then vehicle.viValue.fill.combineFill = true;end;
					vehicle.viValue.fill.isSeedsOrSprayer = true;
					if tonumber(fillLevelProzent) <= 100-seeNoDrawWarningFillLevel then
						vehicle.viValue.fill.isWarning = true;						
						if not isAttached or (isAttached and viGui.defaultHud.seeNoDrawWarning.attachedFill) then
							masterVehicle.viValue.globalWarning.isWarning = true;				
						end;
						if tonumber(fillLevelProzent) <= 0 then masterVehicle.viValue.globalWarning.warningTxt = "! Empty !";end;
					end;
				elseif tonumber(fillLevelProzent) >= seeNoDrawWarningFillLevel then
					vehicle.viValue.fill.isWarning = true;					
					if not isAttached or (isAttached and viGui.defaultHud.seeNoDrawWarning.attachedFill) then
						masterVehicle.viValue.globalWarning.isWarning = true;				
					end;
					if tonumber(fillLevelProzent) >= 100 then masterVehicle.viValue.globalWarning.warningTxt = "! Full !";end;
				end;
			end;
		end;
	end;
	function setDirtAmount()
		local dirtAmount = viSetGet:getDirtAmountProzentAndColor(self, vehicle);		
		if dirtAmount ~= nil then
			vehicle.viValue.dirtAmount.dirtAmountProzent = dirtAmount;
			if viGui.defaultHud.seeNoDrawWarning.dirtAmount ~= -1 and tonumber(vehicle.viValue.dirtAmount.dirtAmountProzent) >= viGui.defaultHud.seeNoDrawWarning.dirtAmount then
				if not isAttached or (isAttached and viGui.defaultHud.seeNoDrawWarning.attachedDirt) then					
					vehicle.viValue.dirtAmount.isWarning = true;
					masterVehicle.viValue.globalWarning.foundDirtAmount = masterVehicle.viValue.globalWarning.foundDirtAmount+1;
				end;
				--if tonumber(vehicle.viValue.dirtAmount.dirtAmountProzent) >= 100 then masterVehicle.viValue.globalWarning.warningTxt = "! Wash !";end;
			end;
		end;
	end;
	function setRentCar()
		if vehicle.propertyState == 2 then
			masterVehicle.viValue.globalWarning.foundRentCar = masterVehicle.viValue.globalWarning.foundRentCar+1;
			masterVehicle.viValue.globalWarning.rentCarCost = masterVehicle.viValue.globalWarning.rentCarCost+(Utils.getNoNil(vehicle:getPrice(),0)/100*6);
		end;
	end;
	function setVehicleCost()
		if vehicle.propertyState ~= 2 then
			local sellPrice, price, multiplier = viSetGet:getSellPriceAndMulitplier(self, vehicle);
			if sellPrice ~= nil and price ~= nil then
				local isPriceProzent = price/100;
				local isSellProzent = sellPrice/isPriceProzent;				
				if tonumber(isSellProzent) >= viGui.defaultHud.seeExtraIcon.vehicleCostProzent then
					vehicle.viValue.price.isWarning = true;
					vehicle.viValue.price.sellPriceProzent = isSellProzent;					
					masterVehicle.viValue.globalWarning.foundVehicleCost = masterVehicle.viValue.globalWarning.foundVehicleCost+1;
				end;
			end;
		end;
	end;
	setFill();
	setFuel();
	setDirtAmount();
	setRentCar();
	setVehicleCost();
	if viGui.defaultHud.seeNoDrawWarning.fillLevel == -1 and viGui.defaultHud.seeNoDrawWarning.fuelLevel == -1 and viGui.defaultHud.seeNoDrawWarning.dirtAmount == -1 and not viGui.defaultHud.seeNoDrawWarning.problemHiredAndForeignPlayer then
		return;
	end;	
	if isAttached then
		
	else
		if not masterVehicle.viValue.globalWarning.isWarning or string.len(masterVehicle.viValue.globalWarning.warningTxt) <= 0 then
			local isControlled = viSetGet:seeControlled(self, masterVehicle);
			vehicle.viValue.controlled = {isWarning=false;isControlled=isControlled};		
			if viGui.defaultHud.seeNoDrawWarning.problemHiredAndForeignPlayer and (string.find(vehicle.controllerShortName, "H") or string.find(vehicle.controllerShortName, "AP")) then
				local problem = viSetGet:getVehicleIsBlockedByControlled(self, masterVehicle);
				if string.len(problem) > 0 then				
					masterVehicle.viValue.globalWarning.isWarning = true;
					masterVehicle.viValue.globalWarning.warningTxt = problem;
				end;
			elseif not isControlled and viGui.defaultHud.seeNoDrawWarning.problemNoControlled then
				local problem = viSetGet:getVehicleIsBlocked(self, masterVehicle);
				if string.len(problem) > 0 then	
					masterVehicle.viValue.globalWarning.isWarning = true;
					masterVehicle.viValue.globalWarning.warningTxt = problem;
				end;
			end;
		end;		
	end;	
end;

function viSetGet:getVehicleIsBlocked(self, vehicle)
	local isBlocked = "";
	if not VehicleInspector.isMp or (VehicleInspector.isMp and VehicleInspector.loadHostServer) then
		if vehicle.debugTexts ~= nil and #vehicle.debugTexts > 0 then	
			if vehicle.debugTexts[1] ~= nil and string.find(vehicle.debugTexts[1], "STOP") and string.find(vehicle.debugTexts[1], "collision") then		
				return "! Collision !";		
			end;	
		end;
	end;
	if vehicle.isBroken	and vehicle.showWaterWarning then return "! Damage (Water) !";
	elseif vehicle.isBroken	then return "! Damage !";	
	elseif vehicle.showWaterWarning	then return "! Water !";	
	elseif vehicle.viVehicleName ~= "Train" and vehicle.viVehicleName ~= "Crane" and not VehicleInspector.isMp and not vehicle.isVehicleSaved then return "! Field Mission !";
	elseif vehicle.isFuelFilling then
		--return "Refuel";
	end;
	return isBlocked;
end;

function  viSetGet:getVehicleIsBlockedByControlled(self, vehicle)
	local isBlocked = "";
	if not VehicleInspector.isMp or (VehicleInspector.isMp and VehicleInspector.loadHostServer) then
		if vehicle.debugTexts ~= nil and #vehicle.debugTexts > 0 then	
			if vehicle.debugTexts[1] ~= nil and string.find(vehicle.debugTexts[1], "STOP") and string.find(vehicle.debugTexts[1], "collision") then		
				return "! Collision !";		
			end;	
		end;
	end;
	function getCollision()
		if not VehicleInspector.isMp or (VehicleInspector.isMp and VehicleInspector.loadHostServer) then return false;end;
		if vehicle.aiIsStarted then
			if vehicle:getLastSpeed() < 0.5 then 
				vehicle.didNotMoveTimer = vehicle.didNotMoveTimer-10;
			else
				vehicle.didNotMoveTimer = vehicle.didNotMoveTimeout;
			end;
			if vehicle.didNotMoveTimer < 0 then return true;end;
		else
			vehicle.didNotMoveTimer = vehicle.didNotMoveTimeout;
		end;
		return false;
	end;
	if vehicle.isBroken	and vehicle.showWaterWarning then return "! Damage (Water) !";
	elseif vehicle.isBroken	then return "! Damage !";	
	elseif vehicle.showWaterWarning	then return "! Water !";
	elseif (vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving() and (vehicle.cp ~= nil and vehicle.cp.wait)) then return "! Wait(CP) !";	
	elseif vehicle.isFuelFilling then return "Refuel";
	--elseif not vehicle.isAllowedToDrive and not vehicle.isHirableBlocked then		
	--	if vehicle.pipeCurrentState ~= nil and vehicle.pipeCurrentState == 2 then
	--		if Utils.getNoNil(vehicle.sendDidOverload,false) then --Utils.getNoNil(vehicle.sentPipeFoundTrailer,false) and Utils.getNoNil(vehicle.trailerFound,0) > 0 and Utils.getNoNil(vehicle.sendDidOverload,false) then
	--			return "! Overloaded !";
	--		elseif not vehicle.combineIsFilling then
	--			return "! Wait (Full) !";			
	--		end;
	--	elseif vehicle.pipeCurrentState ~= nil and vehicle.pipeCurrentState == 1 then
	--		if Utils.getNoNil(vehicle.sendDidOverload,false) or not vehicle.combineIsFilling then --Utils.getNoNil(vehicle.sentPipeFoundTrailer,false) and Utils.getNoNil(vehicle.trailerFound,0) > 0 and Utils.getNoNil(vehicle.sendDidOverload,false) then
	--			return "! Full !";						
	--		end;
	--	end;		
	--elseif vehicle.isAllowedToDrive then		
	--	if vehicle.pipeCurrentState ~= nil and (vehicle.pipeCurrentState == 1 or vehicle.pipeCurrentState == 2) then
	--		if Utils.getNoNil(vehicle.sendDidOverload,false) or not vehicle.combineIsFilling and vehicle.lastSpeed <= 0 then --Utils.getNoNil(vehicle.sentPipeFoundTrailer,false) and Utils.getNoNil(vehicle.trailerFound,0) > 0 and Utils.getNoNil(vehicle.sendDidOverload,false) then
	--			return "! Wait !";						
	--		end;
	--	end;		
	elseif vehicle.viVehicleName ~= "Train" and vehicle.viVehicleName ~= "Crane" and not VehicleInspector.isMp and not vehicle.isVehicleSaved then return "! Field Mission !";	
	--elseif getCollision() then return "! Collision !";end;
	elseif vehicle.isHirableBlocked then return "! Hired Blocked !";	
	end;
	return isBlocked;
end;

function viSetGet:setGetNumberColor(self, number, multi, getColor, reverseColor, overlay, colorType)			
	local color = viGui.defaultHud.warningColor0;
	if (type(number) == "string" or string.find(number, "inf")) or string.find(number, "nan") or (colorType == "animal" and g_currentMission.husbandries[overlay].updateMinutes <= 0) then
		if overlay ~= nil then
			viGui:setBackgroundColor(self, viGui[overlay], viExtras.colors["grayInactive"]);
			return;
		elseif getColor then
			return viExtras.colors["grayInactive"];
		end;
	end;
	local prozent = string.format("%1.0f", Utils.getNoNil(number*multi, 0));
	if tonumber(prozent) >= 80 then	
		if overlay ~= nil then
			viGui:setBackgroundColor(self, viGui[overlay], viGui.defaultHud.warningColor0);
			return;
		elseif getColor then
			if reverseColor then
				return viGui.defaultHud.warningColor4;
			else
				return viGui.defaultHud.warningColor0;
			end;
		end;
	elseif tonumber(prozent) < 80 and tonumber(prozent) >= 60 then
		if overlay ~= nil then
			viGui:setBackgroundColor(self, viGui[overlay], viGui.defaultHud.warningColor1);
			return;
		elseif getColor then
			if reverseColor then
				return viGui.defaultHud.warningColor3;
			else
				return viGui.defaultHud.warningColor1;
			end;
		end;
	elseif tonumber(prozent) < 60 and tonumber(prozent) >= 40 then
		if overlay ~= nil then
			viGui:setBackgroundColor(self, viGui[overlay], viGui.defaultHud.warningColor2);
			return;
		elseif getColor then			
			return viGui.defaultHud.warningColor2;
		end;
	elseif tonumber(prozent) < 40 and tonumber(prozent) >= 20 then
		if overlay ~= nil then
			viGui:setBackgroundColor(self, viGui[overlay], viGui.defaultHud.warningColor3);
			return;
		elseif getColor then
			if reverseColor then
				return viGui.defaultHud.warningColor1;
			else
				return viGui.defaultHud.warningColor3;
			end;
		end;
	elseif tonumber(prozent) < 20 then
		if overlay ~= nil then
			viGui:setBackgroundColor(self, viGui[overlay], viGui.defaultHud.warningColor4);
			return;
		elseif getColor then
			if reverseColor then
				return viGui.defaultHud.warningColor0;
			else
				return viGui.defaultHud.warningColor4;
			end;
		end;
	end;	
end;

function viSetGet:getFillLevelInformation(vehicle, fillLevelInformations, isAttached, nr)
    --if #fillLevelInformations > 5 then return;end;
	local attachedNextNr = nr;
	if vehicle.fillUnits ~= nil then
        for _,fillUnit in pairs(vehicle.fillUnits) do
            --if fillUnit.capacity ~= nil then --and fillUnit.showOnHud then
                local added = false;               
				local isSeeds = false;
				local isSprayer = false;
				local seedsFruitType = 0;
				local seedsFruitConvertFillType = 0;
				local sprayerFillType = 0;
				local sprayerFruitConvertFillType = 0;
				if vehicle.seeds ~= nil and vehicle.currentSeed ~= nil then
					isSeeds = true;
					seedsFruitType = Utils.getNoNil(vehicle.seeds[vehicle.currentSeed], 0);
					seedsFruitConvertFillType = Utils.getNoNil(FruitUtil.fruitTypeToFillType[seedsFruitType], 0);
				end;
				if vehicle.sprayer ~= nil then
					isSprayer = true;
					for fType,state in pairs(fillUnit.fillTypes) do
						if state then
							sprayerFillType = fType;
							sprayerFruitConvertFillType = Utils.getNoNil(FruitUtil.fruitTypeToFillType[sprayerFillType], 0);
							break;
						end;
					end;
				end;
				--for i,fillLevelInformation in pairs(fillLevelInformations) do
                --    if fillLevelInformation.fillType == fillUnit.currentFillType then
                --        fillLevelInformation.fillType = fillUnit.currentFillType;
				--		fillLevelInformation.fillLevel = fillUnit.fillLevel;
                --        fillLevelInformation.capacity = fillUnit.capacity;
                --        added = true;
                --        break;
                --    end
                --end
                if not added then
                    --fillLevelInformations[#fillLevelInformations+1] = {fillType=fillUnit.currentFillType, fillLevel=fillUnit.fillLevel, capacity=fillUnit.capacity};
					table.insert(fillLevelInformations, {
					fillType=fillUnit.currentFillType, 
					fillLevel=fillUnit.fillLevel, 
					capacity=Utils.getNoNil(fillUnit.capacity, 0),
					isSeeds=isSeeds, 
					seedsFruitType=seedsFruitType, 
					seedsFruitConvertFillType=seedsFruitConvertFillType, 
					isSprayer=isSprayer, 
					sprayerFillType=sprayerFillType,
					sprayerFruitConvertFillType=sprayerFruitConvertFillType,
					isAttached=isAttached,
					attachedNr = attachedNextNr;
					});					
                end;
            --end;
        end;
    end;
	attachedNextNr = attachedNextNr+1;
    for _, implement in pairs(vehicle.attachedImplements) do
       if implement.object ~= nil then
            viSetGet:getFillLevelInformation(implement.object, fillLevelInformations, true, attachedNextNr);			
       end;
    end;
end;

function viSetGet:getAttachedSelect(self, vehicle)
	local attachedNode = nil;
	for _, implement in pairs(vehicle.attachedImplements) do
       if implement.object ~= nil then
           if implement.object.isSelected then 
			attachedNode = implement.object.rootNode;
		   elseif implement.object.attachedImplements then 
			attachedNode = viSetGet:getAttachedSelect(self, implement.object);
		   end;
       end;
    end;
	return attachedNode;
end;